<template>
  <q-page class="Pageuserform flex flex-center bg-img">
    <div></div>
    <div>
      <q-form
        class="userForm q-ma-xl bg-dark q-pa-lg"
        ref="resetValidation"
        v-if="currentForm === 1"
      >
        <h2 class="text-h2 headerText text-center text-weight-bold q-ma-none">
          USER FORM
        </h2>

        <q-input
          dark
          rounded
          standout
          v-model="form.name"
          label="Name"
          hint="Firstname Surname"
          hide-hint
          lazy-rule
        >
        </q-input>
        <q-input
          dark
          rounded
          standout
          v-model="form.username"
          label="Username"
          hide-hint
          lazy-rule
          hint="Your Username"
          bottom-slots
        >
        </q-input>
        <q-input
          dark
          rounded
          standout
          v-model="form.email"
          label="Email"
          hide-hint
          lazy-rule
          type="email"
          bottom-slots
          hint="Ex: ben@gmail.com"
        >
        </q-input>
        <q-input
          dark
          rounded
          standout
          v-model="form.phone"
          label="Phone Number"
          mask="+639 - ### - ### - ###"
          hint="Ex: +639 - ### - ### - ###"
          unmasked-value
          hide-hint
          lazy-rule
          bottom-slots
        >
        </q-input>
        <q-input
          dark
          rounded
          standout
          v-model="form.website"
          label="Website"
          hide-hint
          lazy-rule
          bottom-slots
          hint="Ex: google.com"
        >
        </q-input>
        <div>
          <q-btn
            color="primary"
            icon="arrow_forward_ios"
            rounded
            push
            @click="currentForm = 2"
          />
        </div>
      </q-form>
      <q-form
        ref="resetValidation"
        v-if="currentForm === 2"
        class="userForm q-ma-xl bg-dark q-pa-lg"
      >
        <h2 class="text-h2 headerText2 text-center text-weight-bold q-ma-none">
          ADDRESS
        </h2>

        <q-input
          class="input"
          dark
          rounded
          standout
          v-model="form.address.street"
          label="Street"
          hide-hint
          lazy-rule
          dense
          bottom-slots
        >
        </q-input>
        <q-input
          dark
          rounded
          standout
          v-model="form.address.suite"
          label="Suite"
          hide-hint
          lazy-rule
          dense
          bottom-slots
        >
        </q-input>
        <q-input
          dark
          rounded
          standout
          v-model="form.address.city"
          label="City"
          hide-hint
          lazy-rule
          dense
          bottom-slots
        >
        </q-input>
        <q-input
          dark
          rounded
          standout
          type="number"
          v-model="form.address.zipcode"
          label="Zip Code"
          hide-hint
          lazy-rule
          dense
          bottom-slots
        >
        </q-input>
        <q-input
          dark
          rounded
          standout
          v-model="form.address.geo.lat"
          label="Latitude"
          type="number"
          hide-hint
          lazy-rule
          dense
          bottom-slots
        >
        </q-input>
        <q-input
          dark
          rounded
          standout
          type="number"
          v-model="form.address.geo.lng"
          label="Longitude"
          hide-hint
          lazy-rule
          dense
          bottom-slots
        >
        </q-input>
        <div>
          <q-btn
            class="btnleft"
            icon="arrow_back_ios_new"
            color="primary"
            rounded
            push
            @click="currentForm = 1"
          />
          <q-btn
            class="btnright"
            icon="arrow_forward_ios"
            color="primary"
            rounded
            push
            @click="currentForm = 3"
          />
        </div>
      </q-form>
      <q-form
        ref="resetValidation"
        v-if="currentForm === 3"
        class="userForm q-ma-xl bg-dark q-pa-lg"
      >
        <h2 class="text-h2 headerText3 text-center text-weight-bold q-ma-none">
          company
        </h2>
        <q-input
          dark
          rounded
          standout
          v-model="form.company.name"
          label="Company Name"
          hide-hint
          lazy-rule
          bottom-slots
        >
        </q-input>
        <q-input
          dark
          rounded
          standout
          v-model="form.company.catchPhrase"
          label="Catch Phrase"
          hide-hint
          lazy-rule
          bottom-slots
        >
        </q-input>
        <q-input
          dark
          rounded
          standout
          v-model="form.company.bs"
          label="BS"
          hide-hint
          lazy-rule
          bottom-slots
        >
        </q-input>
        <div>
          <q-btn
            class="btnleft2"
            icon="arrow_back_ios_new"
            color="primary"
            rounded
            push
            @click="currentForm = 2"
          />
          <q-btn
            class="btnright2"
            color="primary"
            icon-right="add_circle"
            label="ADD"
            rounded
            push
            :loading="btnLoadingState"
            @click="addUserData()"
          />
        </div>
      </q-form>
    </div>
  </q-page>
</template>

<script>
import { ref } from "vue";
import {
  addUserData,
  resetValidation,
  btnUserFormState,
  btnAddressState,
  btnLoadingState,
  btnCompanyState,
} from "../Composables/FunctVar";

let form = ref({
  id: null,
  name: null,
  username: null,
  email: null,
  address: {
    street: null,
    suite: null,
    city: null,
    zipcode: null,
    geo: {
      lat: null,
      lng: null,
    },
  },
  phone: null,
  website: null,
  company: {
    name: null,
    catchPhrase: null,
    bs: null,
  },
});

let currentForm = ref(1);
export default {
  setup() {
    return {
      resetValidation,
      form,
      currentForm,
      addUserData,
      btnUserFormState,
      btnLoadingState,
      btnAddressState,
      btnCompanyState,
    };
  },
};

export { form, currentForm };
</script>

<style>
.headerText {
  font-size: 25px;
  color: white;
}
.userForm {
  border-radius: 15px;
  width: 500px;
  height: 600px;
  display: block;
  justify-content: center;
  align-items: center;
  text-align: center;
  margin: 0 auto;
  color: white;
}
.headerText2 {
  font-size: 25px;
  color: white;
}
.headerText3 {
  font-size: 25px;
  color: white;
}
.q-input {
  width: 400px;
  margin: 15px auto 15px auto;
}
.q-btn {
  width: 160px;
}
.btnleft {
  margin-right: 20px;
}
.btnright {
  margin-left: 20px;
}
.btnleft2 {
  margin-right: 20px;
}
.btnright2 {
  margin-left: 20px;
}
.Pageuserform {
  background-image: url("../assets/bg1.jpg");
  background-repeat: no-repeat;
  background-attachment: fixed;
  background-size: 100% 100%;
  background-size: cover;
}
</style>
